import React from "react";
import { GridColDef } from "@mui/x-data-grid-pro";
declare type commonProps = {
    rows: object[];
    columns: GridColDef[];
    columnsVisibility?: {
        [key: string]: boolean;
    };
    onSelect?: (selectedRows: {
        [key: string]: unknown;
    }[]) => void;
    apiExportEndpoint?: string;
    defaultSelectRowID?: number;
    createNewButton?: JSX.Element;
    initialRowsPerPage?: 10 | 50 | 100;
};
declare type optionalProps = {
    hidePagination?: false;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination: true;
    hideFilters: true;
    culumnsMatchingFilterName?: never;
    getRows?: never;
    requestPending?: never;
    dispatch?: never;
    queryParams?: never;
    setQueryparams?: never;
    networkCompletionStack?: never;
} | {
    hidePagination: true;
    hideFilters?: false;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName: Map<string, string>;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
} | {
    hidePagination?: false;
    hideFilters: true;
    /**
     * Map of column field and its corresponding searchMetadata name.
     */
    culumnsMatchingFilterName?: never;
    getRows: (body: Record<string, unknown>) => void;
    requestPending: boolean;
    queryParams: Record<string, string>;
    setQueryparams: (query: Record<string, unknown>) => void;
    networkCompletionStack: Record<string, boolean>[];
};
declare type propsType = commonProps & optionalProps;
/**
 * NerdDataGrid component.
 *
 * @param {propsType} props NerdDataGrid props.
 * @returns {React.ReactElement} DataGrid wrapper with server-side filters.
 */
declare function NerdDataGrid(props: propsType): React.ReactElement;
export default NerdDataGrid;
